<?php
/**
* set_env.php
* @author Luc Saillard <luc@saillard.org>
* @version 0.1
*
* Class News, to display page, template, load files, ...
*/


class News extends Page
{

  function News()
  {
    $this->Page();
  }

  function display_page()
  {
    $this->assign("document_template" , "newsitem_view.tpl");
    $meta_infos = $this->load_news_file(WWW_DIR.$this->me());
    foreach ($meta_infos  as $key => $value) {
      $this->assign($key,$value);
    }
    $this->__display_page();
  }

  function load_news_file($newsfile)
  {
    $meta_infos = array();
    if (!file_exists($newsfile)) {
      return $meta_infos;
    }

    $fd = fopen($newsfile,"r");
    if (!$fd) {
      return $meta_infos;
    }

    # A news file, is a php script, and data is put between two separator.
    $parse_headers = 1; # do we parse the header ?
    $in_data = 0;	# Are we in the document data ?
    $buffer = "";
    while (!feof($fd)) {
      $line = fgets($fd,4096);

      if ($in_data==0 && ereg("^/\*\*\*\* BEGIN DOCUMENT \*\*\*\*/",$line)) {
	$in_data = 1;
	continue;
      } else if ($in_data && ereg("^/\*\*\*\* END DOCUMENT \*\*\*\*/",$line)) {
	$in_data = 0;
	break;
      }
      if (!$in_data) {
	continue;
      }

      if ($parse_headers) {
	# If it's an header line, add it into the table of headers lines
	if (ereg("^([a-zA-Z0-9_-]+): (.*)$", $line, $regs)) {
	  $key = $regs[1];
	  $meta_infos[$key] = trim($regs[2]);
	} else {
	  # ... else add this is the end of the headers, so discard the line
	  $parse_headers = 0;
	}
      # Parse the body (ie add it to the current buffer)
      } else {
	$buffer .= $line;
      }
    }
    # Ok all lines is parsed, so assign value.
    fclose($fd);
    $meta_infos['document_content'] = $buffer;
    $meta_infos['document_date'] = filemtime($newsfile);
    return $meta_infos;
  } /* end of load_news_file */


} /* class News */

?>
