<?php

/**
* PageNews.php
* @author Luc Saillard <luc@saillard.org>
* @version 0.1
*
* PageNews to display all recent news, on one page.
*/


// Create a wrapper class extended from Smarty
class PageNews  extends Page
{
  function PageNews ()
  {
    $this->Page();
  }

  function display_page()
  {
    $this->assign("document_template" , "news.tpl");
    $newsfolder = WWW_DIR."/news/";
    $this->fill_news_template($newsfolder,"/news/");

    $this->__display_page();
  }

  function fill_news_template($newsfolder,$urlfolder)
  {
    if (!is_dir($newsfolder))
      return false;
    $fd = opendir($newsfolder);
    if (!$fd)
      return false;

    $news_list = array();
    while (false !== ($file = readdir($fd))) {
      $fullfilename = "$newsfolder$file";
      if ( $file[0]=='.' || !ereg("\.php$",$file) || is_dir($fullfilename)) {
	# Skip, file or directory that begins with a .
	# Skip link, directory, ..., and metadata file
	continue;
      }

      $newsobj = new News();
      $news_infos = $newsobj->load_news_file($fullfilename);
      $news_infos['url'] = "$urlfolder$file";
      $news_list[] = $news_infos;

    } /* end of while ( ... readdir() ) */
    closedir($fd);

    usort($news_list,array($this,"cmp_date"));

    $this->assign("news_list",$news_list);
  }
  /* end of function fill_news_template() */

  function cmp_date($a,$b)
  {
    if ($a['document_date'] == $b['document_date']) {
      return 0;
    }
    return ($a['document_date'] > $b['document_date']) ? -1 : 1;
  }


} /* class PageNews  */

?>
